routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('auth.login');
});

Auth::routes([
  'register' => false, // Registration Routes...
  'reset' => false, // Password Reset Routes...
  'verify' => false, // Email Verification Routes...
]);

Route::group(['middleware' => ['auth']], function() {
    Route::resource('roles','RoleController');
    Route::resource('users','UserController');
    Route::resource('projects','ProjectController');
    Route::resource('tasks','TaskController');
    Route::resource('comments','CommentController');
    Route::resource('logworks','LogworkController');
    
    ROute::get('changestatusproject/{id}/{pid}','ProjectController@changeStatus');
    Route::get('logworkremoved/{id}','LogworkController@is_removed');
    Route::get('download-logworks/{name}','LogworkController@download');
    Route::get('commentremoved/{id}','CommentController@is_removed');
    Route::get('download-comments/{name}','CommentController@download');
    Route::get('create-task/{id}','TaskController@createTicket');
    Route::get('task/{id}','TaskController@index');
    Route::get('download-attachemnt/{name}','TaskController@download');
});

Route::get('/home', 'HomeController@index')->name('home');
Route::resource('yourwork','YourworkController');
Route::get('projectExcel','ProjectController@excel');
Route::get('userBlock/{id}','UserController@userBlock');
Route::get('editUser/{id}','UserController@editUser');
Route::put('updateUser/{id}','UserController@updateUser');
Route::get('changePassword/{id}','UserController@changePassword');
Route::put('updatePassword/{id}','UserController@updatePassword');
Route::resource('logs','LogController');
Route::get('download/{filename}', 'LogController@getDownload');
// LocalizationController
Route::get('lang/{locale}', 'LocalizationController@index');
// ROUTE for getImage from photos folder
Route::get('/photos/{filename}', function ($filename)
{
    $path = storage_path() . '/photos/' . $filename;
    if(!File::exists($path)) abort(404);
    $file = File::get($path);
    $type = File::mimeType($path);
    $response = Response::make($file, 200);
    $response->header("Content-Type", $type);
    return $response;
})->name('photo');

app/Http/Controllers/RoleController.php
<?php

namespace App\Http\Controllers;

use Illuminate\Http\Request;
use App\Http\Controllers\Controller;
use Spatie\Permission\Models\Role;
use Spatie\Permission\Models\Permission;
use DB;

class RoleController extends Controller
{

    /**

     * Display a listing of the resource.

     *

     * @return \Illuminate\Http\Response

     */

    function __construct()

    {

         $this->middleware('permission:role-list|role-create|role-edit|role-delete', ['only' => ['index','store']]);

         $this->middleware('permission:role-create', ['only' => ['create','store']]);

         $this->middleware('permission:role-edit', ['only' => ['edit','update']]);

         $this->middleware('permission:role-delete', ['only' => ['destroy']]);

    }



    /**

     * Display a listing of the resource.

     *

     * @return \Illuminate\Http\Response

     */

    public function index(Request $request)

    {
        $roles = Role::orderBy('id','DESC')->paginate(5);
        $data1 = array(
            'title'=>'Roles',
            'description'=>'This is New Application',
            'author'=>'foo'
            );
        return view('roles.index',compact('roles'))->with($data1);

    }



    /**

     * Show the form for creating a new resource.

     *

     * @return \Illuminate\Http\Response

     */

    public function create()
    {
        $permission = Permission::get();
        $data1 = array(
            'title'=>'Roles',
            'description'=>'This is New Application',
            'author'=>'foo'
            );
        return view('roles.create',compact('permission'))->with($data1);
    }



    /**

     * Store a newly created resource in storage.

     *

     * @param  \Illuminate\Http\Request  $request

     * @return \Illuminate\Http\Response

     */

    public function store(Request $request)
    {
        $this->validate($request, [
            'name' => 'required|unique:roles,name',
            'permission' => 'required',
        ]);
        $role = Role::create(
            ['key' => $request->input('key'),
            'name' =>$request->input('name'),
            'description' =>$request->input('description')]);
        $role->syncPermissions($request->input('permission'));
        return redirect()->route('roles.index')
                        ->with('success','Role created successfully');

    }

    /**

     * Display the specified resource.

     *

     * @param  int  $id

     * @return \Illuminate\Http\Response

     */

    public function show($id)

    {

        $role = Role::find($id);

        $rolePermissions = Permission::join("role_has_permissions","role_has_permissions.permission_id","=","permissions.id")

            ->where("role_has_permissions.role_id",$id)

            ->get();

            $data1 = array(
            'title'=>'Role Management',
            'description'=>'This is New Application',
            'author'=>'foo'
            );

        return view('roles.show',compact('role','rolePermissions'))->with($data1);

    }



    /**

     * Show the form for editing the specified resource.

     *

     * @param  int  $id

     * @return \Illuminate\Http\Response

     */

    public function edit($id)

    {

        $role = Role::find($id);

        $permission = Permission::get();

        $rolePermissions = DB::table("role_has_permissions")->where("role_has_permissions.role_id",$id)

            ->pluck('role_has_permissions.permission_id','role_has_permissions.permission_id')

            ->all();

        $data1 = array(
            'title'=>'Roles',
            'description'=>'This is New Application',
            'author'=>'foo'
            );

        return view('roles.edit',compact('role','permission','rolePermissions'))->with($data1);

    }



    /**

     * Update the specified resource in storage.

     *

     * @param  \Illuminate\Http\Request  $request

     * @param  int  $id

     * @return \Illuminate\Http\Response

     */

    public function update(Request $request, $id)
    {
        $this->validate($request, [
            'name' => 'required',
            'permission' => 'required',
        ]); 
        $role = Role::find($id);
        $role->key = $request->input('key');
        $role->name = $request->input('name');
        $role->description = $request->input('description');
        $role->save();
        $role->syncPermissions($request->input('permission'));
        return redirect()->route('roles.index')
                        ->with('success','Role updated successfully');

    }

    /**

     * Remove the specified resource from storage.

     *

     * @param  int  $id

     * @return \Illuminate\Http\Response

     */

    public function destroy($id)
    {
        DB::table("roles")->where('id',$id)->delete();
        return redirect()->route('roles.index')
                        ->with('success','Role deleted successfully');

    }

}

resources/views/roles/create.blade.php
@extends('layouts.app') @section('content-wrapper')
<div class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1 class="m-0 text-dark">{{ __('veacha.role') }}</h1>
            </div>
            <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                    @can('role-create')
                    <li class="breadcrumb-item"><a href="{{ route('roles.create') }}" class="btn btn-primary m-0 pull-left">{{ __('veacha.add_role')}}</a>
                    </li>
                    @endcan
                </ol>
            </div>
        </div>
    </div>
</div>
@endsection @section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-lg-12 col-12">
            @if ($message = Session::get('success'))
            <div class="alert alert-success">
                <p>{{ $message }}</p>
            </div>
            @endif
            <div class="card">
                
                <div class="card-body">
                    @if (count($errors) > 0)
                    <div class="alert alert-danger">
                        <strong>Whoops!</strong> There were some problems with your input.
                        <br>
                        <br>
                        <ul>
                            @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                            @endforeach
                        </ul>
                    </div>
                    @endif
                    <form role="form" action="{{ route('roles.store') }}" method="POST">
                         {{csrf_field()}}
                        <div class="row">
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                <div class="form-group">
                                    <label for="exampleInputEmail1">{{ __('veacha.key')}} <i class="text-red">*</i></label>
                                    <input type="text" name="key" class="form-control form-control-sm col-5" id="exampleInputEmail1" placeholder="Enter key">
                                </div>
                            </div>
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                <div class="form-group">
                                    <label for="exampleInputEmail1">{{ __('veacha.role')}} <i class="text-red">*</i></label>
                                    <input type="text" name="name" class="form-control form-control-sm col-5" id="exampleInputEmail1" placeholder="Enter role name">
                                </div>
                            </div>
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                <div class="form-group">
                                    <label for="exampleInputEmail1">{{ __('veacha.description')}} <i class="text-red">*</i></label>
                                    <input type="text" name="description" class="form-control form-control-sm col-5" id="exampleInputEmail1" placeholder="Enter description">
                                </div>
                            </div>
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                <div class="form-group">
                                    <strong>{{ __('veacha.permission')}} </strong>
                                    <br/> 
                                    @foreach($permission as $value)
                                    <div class="custom-control custom-checkbox">
                                        <input class="custom-control-input" type="checkbox" name="permission[]" id="{{ $value->id }}" value="{{ $value->id }}">
                                        <label for="{{ $value->id }}" class="custom-control-label">{{ $value->name }}</label>
                                    </div>
                                    <br/>
                                    @endforeach
                                </div>
                            </div>
                            <div class="col-xs-12 col-sm-12 col-md-12 text-center">
                                <button type="submit" class="btn btn-primary">{{ __('veacha.submit')}}</button>
                            </div>
                        </div>
                    </form>
                    <br>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/roles/edit.blade.php
@extends('layouts.app') @section('content-wrapper')
<div class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1 class="m-0 text-dark">{{ __('veacha.role')}}</h1>
            </div>
            <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                    @can('role-create')
                    <li class="breadcrumb-item"><a href="{{ route('roles.create') }}" class="btn btn-primary m-0 pull-left">{{ __('veacha.add_role')}}</a>
                    </li>
                    @endcan
                </ol>
            </div>
        </div>
    </div>
</div>
@endsection @section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-lg-12 col-12">
            @if ($message = Session::get('success'))
            <div class="alert alert-success">
                <p>{{ $message }}</p>
            </div>
            @endif
            <div class="card">
                
                <div class="card-body">
                    @if (count($errors) > 0)
                    <div class="alert alert-danger">
                        <strong>Whoops!</strong> There were some problems with your input.
                        <br>
                        <br>
                        <ul>
                            @foreach ($errors->all() as $error)
                            <li>{{ $error }}</li>
                            @endforeach
                        </ul>
                    </div>
                    @endif
                    <form role="form" action="{{ route('roles.update', $role->id) }}" method="POST">
                        {{ csrf_field() }}
                        {{ method_field('PATCH') }}
                        <div class="row">                        
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                <div class="form-group">
                                    <label for="exampleInputEmail1">{{ __('veacha.key')}} <i class="text-red">*</i></label>
                                    <input type="text" name="key" class="form-control form-control-sm col-5" id="exampleInputEmail1" value="{{ $role->key}}" placeholder="Enter key">
                                </div>
                            </div>
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                <div class="form-group">
                                    <label for="exampleInputEmail1">{{ __('veacha.role')}} <i class="text-red">*</i></label>
                                    <input type="text" name="name" class="form-control form-control-sm col-5" id="exampleInputEmail1" value="{{ $role->name}}" placeholder="Enter role name">
                                </div>
                            </div>
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                <div class="form-group">
                                    <label for="exampleInputEmail1">{{ __('veacha.description')}} <i class="text-red">*</i></label>
                                    <input type="text" name="description" class="form-control form-control-sm col-5" id="exampleInputEmail1" value="{{ $role->description}}" placeholder="Enter description">
                                </div>
                            </div>
                            <div class="col-xs-12 col-sm-12 col-md-12">
                                <div class="form-group">
                                    <strong>{{ __('veacha.permission') }}</strong>
                                    <br/>
                                    @foreach($permission as $value)
                                        <label>{{ Form::checkbox('permission[]', $value->id, in_array($value->id, $rolePermissions) ? true : false, array('class' => 'name')) }}
                                        {{ $value->name }}</label><br/>
                                    @endforeach
                                </div>
                            </div>
                            <div class="col-xs-12 col-sm-12 col-md-12 text-center">
                                <button type="submit" class="btn btn-primary">{{ __('veacha.submit')}}</button>
                            </div>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

resources/views/roles/index.blade.php
@extends('layouts.app') @section('content-wrapper')
<div class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1 class="m-0 text-dark">{{ __('veacha.role_page') }}</h1>
            </div>
            <!-- /.col -->
            <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                    @can('role-create')
                    <li class="breadcrumb-item"><a href="{{ route('roles.create') }}" class="btn btn-primary m-0 pull-left">{{ __('veacha.button_new_role')}}</a>
                    </li>
                    @endcan
                </ol>
            </div>
        </div>
    </div>
</div>
@endsection @section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-lg-12 col-12">
            @if ($message = Session::get('success'))
            <div class="alert alert-success">
                <p>{{ $message }}</p>
            </div>
            @endif            
            <div class="card">
                <div class="card-body table-responsive">
                    <div class="input-group input-group-sm" style="width: 250px;border: 1px solid #ced4da;">
                        <input type="text" name="table_search" class="form-control float-right" id="searchRole" style="border: 0px;" placeholder="Search role ...">

                        <div class="input-group-append">
                            <button type="submit" class="btn btn-default"><i class="fas fa-search"></i></button>
                        </div>
                    </div>
                    <br>
                    <table class="table table-bordered table-hover datatable">
                        <thead>
                        <tr>
                            <th width="20px">{{ __('veacha.no')}}</th>
                            <th>{{ __('veacha.key')}}</th>
                            <th>{{ __('veacha.role')}}</th>
                            <th>{{ __('veacha.description')}}</th>
                            <th width="280px">{{ __('veacha.action')}}</th>
                        </tr>
                        </thead>
                        <tbody id="role">
                        @foreach ($roles as $key => $role)
                        <tr>
                            <td>{{ ++$key }}</td>
                            <td>{{ $role->key }}</td>
                            <td>{{ $role->name }}</td>
                            <td>{{ $role->description }}</td>
                            <td>
                            @can('role-list')<a class="btn btn-outline-primary btn-sm" href="{{ route('roles.show',$role->id) }}" title="View"><i class="fas fa-folder"></i> </a>@endcan 
                            @can('role-edit')<a class="btn btn-outline-primary btn-sm" href="{{ route('roles.edit',$role->id) }}" title="Edit"><i class="fas fa-edit"></i></a>@endcan 
                            @can('role-delete')<form action="{{ route('roles.destroy',$role->id ) }}" method="POST" style="display:inline">
                                    {{ csrf_field() }} {{ method_field('DELETE') }}
                                    <button type="submit" class="btn-outline-danger btn-sm btn-delete" title="Delete"><i class="fas fa-trash"></i></button>
                            </form>@endcan
                            </td>
                        </tr>
                        @endforeach
                        </tbody>
                    </table>
                    {!! $roles->render() !!}
                </div>
            </div>
        </div>
    </div>
</div>
@endsection

@section('js')
    <script>
        $(function () {
            $("#searchRole").on("keyup", function() {
                var value = $(this).val().toLowerCase();
                $("#role tr").filter(function() {
                $(this).toggle($(this).text().toLowerCase().indexOf(value) > -1)
                });
            });
        });
    </script>
@include('notification') 
@endsection

resources/views/roles/show.blade.php
@extends('layouts.app') @section('content-wrapper')
<div class="content-header">
    <div class="container-fluid">
        <div class="row mb-2">
            <div class="col-sm-6">
                <h1 class="m-0 text-dark">{{ $title }}</h1>
            </div>
            <!-- /.col -->
            <div class="col-sm-6">
                <ol class="breadcrumb float-sm-right">
                    @can('role-create')
                    <li class="breadcrumb-item"><a href="{{ route('roles.index') }}" class="btn btn-primary m-0 pull-left">List Role</a>
                    </li>
                    @endcan
                </ol>
            </div>
        </div>
    </div>
</div>
@endsection @section('content')
<div class="container-fluid">
    <div class="row">
        <div class="col-lg-12 col-12">
            @if ($message = Session::get('success'))
            <div class="alert alert-success">
                <p>{{ $message }}</p>
            </div>
            @endif
            <div class="card">
                <!-- /.card-header -->
                <div class="card-body">
                    <div class="col-xs-12 col-sm-12 col-md-12">
                        <div class="form-group">
                            <strong>Name:</strong> {{ $role->name }}
                        </div>
                    </div>
                    <div class="col-xs-12 col-sm-12 col-md-12">
                        <div class="form-group">
                            <strong>Permissions:</strong> @if(!empty($rolePermissions)) @foreach($rolePermissions as $v)
                            <label class="label label-success">{{ $v->name }},</label>
                            @endforeach @endif
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>
@endsection